var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import { ref, watch, watchEffect, onUnmounted, computed, isRef, toRefs, reactive, onMounted, markRaw, onBeforeUnmount, nextTick } from "vue";
import { d as debounce_1, t as throttle_1, C as Cookies, i as init, l as lodash, q as queryString } from "./.pnpm.03591073.js";
function useAsyncOrder({ task, option }) {
  const { delay = 0, onError, onReady, onSuccess } = option != null ? option : {};
  if (!(task instanceof Array)) {
    throw new Error("task must be Array");
  }
  const interruptibleError = (reason) => {
    onError == null ? void 0 : onError(reason);
  };
  const interruptibleReject = (resolve) => {
    return (error) => {
      interruptibleError(error);
      resolve == null ? void 0 : resolve({ error });
    };
  };
  const runTask = () => {
    var _a;
    (_a = task.length == 1 ? [0] : Array(...task.keys())) == null ? void 0 : _a.reduce((promise, index) => {
      const promise_ = promise.then((res) => {
        if (!(res == null ? void 0 : res.error)) {
          onSuccess == null ? void 0 : onSuccess(res);
        }
        return new Promise((resolve) => {
          var _a2;
          (_a2 = task == null ? void 0 : task[index]) == null ? void 0 : _a2.call(task, resolve, interruptibleReject(resolve), index);
        });
      });
      return promise_;
    }, Promise.resolve());
  };
  useTimeout(() => {
    onReady == null ? void 0 : onReady();
    runTask();
  }, delay);
}
const useAutoRunPlugin = (fetchInstance, {
  manual,
  ready = ref(true),
  defaultParams = [],
  refreshDeps = [],
  refreshDepsAction
}) => {
  watch(ready, (curr) => {
    if (curr && !manual) {
      fetchInstance.run(...defaultParams);
    }
  });
  watch([...refreshDeps], () => {
    if (!manual) {
      if (refreshDepsAction) {
        refreshDepsAction();
      } else {
        fetchInstance.refresh();
      }
    }
  });
  return {
    onBefore: () => {
      if (!ready.value) {
        return {
          stopNow: true
        };
      }
    }
  };
};
useAutoRunPlugin.onInit = ({ ready = ref(true), manual }) => {
  return {
    loading: !manual && ready.value
  };
};
const cache = /* @__PURE__ */ new Map();
const setCache = (key, cacheTime, cachedData) => {
  const currentCache = cache.get(key);
  if (currentCache == null ? void 0 : currentCache.timer) {
    clearTimeout(currentCache.timer);
  }
  let timer = void 0;
  if (cacheTime > -1) {
    timer = setTimeout(() => {
      cache.delete(key);
    }, cacheTime);
  }
  cache.set(key, __spreadProps(__spreadValues({}, cachedData), {
    timer
  }));
};
const getCache = (key) => {
  return cache.get(key);
};
const cachePromise = /* @__PURE__ */ new Map();
const getCachePromise = (cacheKey) => {
  return cachePromise.get(cacheKey);
};
const setCachePromise = (cacheKey, promise) => {
  cachePromise.set(cacheKey, promise);
  promise.then((res) => {
    cachePromise.delete(cacheKey);
    return res;
  }).catch((err) => {
    cachePromise.delete(cacheKey);
    throw err;
  });
};
const listeners$2 = {};
const trigger = (key, data) => {
  if (listeners$2[key]) {
    listeners$2[key].forEach((item) => item(data));
  }
};
const subscribe$2 = (key, listener) => {
  if (!listeners$2[key]) {
    listeners$2[key] = [];
  }
  listeners$2[key].push(listener);
  return function unsubscribe() {
    const index = listeners$2[key].indexOf(listener);
    listeners$2[key].splice(index, 1);
  };
};
const useCachePlugin = (fetchInstance, {
  cacheKey,
  cacheTime = 5 * 60 * 1e3,
  staleTime = 0,
  setCache: customSetCache,
  getCache: customGetCache
}) => {
  const unSubscribeRef = ref();
  const currentPromiseRef = ref();
  const _setCache = (key, cachedData) => {
    if (customSetCache) {
      customSetCache(cachedData);
    } else {
      setCache(key, cacheTime, cachedData);
    }
    trigger(key, cachedData.data);
  };
  const _getCache = (key, params = []) => {
    if (customGetCache) {
      return customGetCache(params);
    }
    return getCache(key);
  };
  watchEffect(() => {
    if (!cacheKey) {
      return;
    }
    const cacheData = _getCache(cacheKey);
    if (cacheData && Object.hasOwnProperty.call(cacheData, "data")) {
      fetchInstance.state.data = cacheData.data;
      fetchInstance.state.params = cacheData.params;
      console.log("staleTime", staleTime);
      if (staleTime === -1 || new Date().getTime() - cacheData.time <= staleTime) {
        fetchInstance.state.loading = false;
      }
    }
    unSubscribeRef.value = subscribe$2(cacheKey, (data) => {
      fetchInstance.setState({ data });
    });
  });
  onUnmounted(() => {
    var _a;
    (_a = unSubscribeRef.value) == null ? void 0 : _a.call(unSubscribeRef);
  });
  if (!cacheKey) {
    return {};
  }
  return {
    onBefore: (params) => {
      const cacheData = _getCache(cacheKey, params);
      if (!cacheData || !Object.hasOwnProperty.call(cacheData, "data")) {
        return {};
      }
      if (staleTime === -1 || new Date().getTime() - cacheData.time <= staleTime) {
        console.log("\u505C\u6B62\u8BF7\u6C42");
        return {
          loading: false,
          data: cacheData == null ? void 0 : cacheData.data,
          returnNow: true
        };
      } else {
        return {
          data: cacheData == null ? void 0 : cacheData.data
        };
      }
    },
    onRequest: (service, args) => {
      let servicePromise = getCachePromise(cacheKey);
      if (servicePromise && servicePromise !== currentPromiseRef.value) {
        return { servicePromise };
      }
      servicePromise = service(...args);
      currentPromiseRef.value = servicePromise;
      setCachePromise(cacheKey, servicePromise);
      return { servicePromise };
    },
    onSuccess: (data, params) => {
      var _a;
      if (cacheKey) {
        (_a = unSubscribeRef.value) == null ? void 0 : _a.call(unSubscribeRef);
        _setCache(cacheKey, {
          data,
          params,
          time: new Date().getTime()
        });
        unSubscribeRef.value = subscribe$2(cacheKey, (d) => {
          fetchInstance.setState({ data: d });
        });
      }
    },
    onMutate: (data) => {
      var _a;
      if (cacheKey) {
        (_a = unSubscribeRef.value) == null ? void 0 : _a.call(unSubscribeRef);
        _setCache(cacheKey, {
          data,
          params: fetchInstance.state.params,
          time: new Date().getTime()
        });
        unSubscribeRef.value = subscribe$2(cacheKey, (d) => {
          fetchInstance.setState({ data: d });
        });
      }
    }
  };
};
const useDebouncePlugin = (fetchInstance, { debounceWait, debounceLeading, debounceTrailing, debounceMaxWait }) => {
  const debouncedRef = ref();
  const options = computed(() => {
    const ret = {};
    if ((debounceLeading == null ? void 0 : debounceLeading.value) !== void 0) {
      ret.leading = debounceLeading.value;
    }
    if ((debounceTrailing == null ? void 0 : debounceTrailing.value) !== void 0) {
      ret.trailing = debounceTrailing.value;
    }
    if ((debounceMaxWait == null ? void 0 : debounceMaxWait.value) !== void 0) {
      ret.maxWait = debounceMaxWait.value;
    }
    return ret;
  });
  watchEffect((onInvalidate) => {
    if (debounceWait) {
      const _originRunAsync = fetchInstance.runAsync.bind(fetchInstance);
      debouncedRef.value = debounce_1((callback) => {
        callback();
      }, debounceWait, options.value);
      fetchInstance.runAsync = (...args) => {
        return new Promise((resolve, reject) => {
          var _a;
          (_a = debouncedRef.value) == null ? void 0 : _a.call(debouncedRef, () => {
            _originRunAsync(...args).then(resolve).catch(reject);
          });
        });
      };
      onInvalidate(() => {
        var _a;
        (_a = debouncedRef.value) == null ? void 0 : _a.cancel();
        fetchInstance.runAsync = _originRunAsync;
      });
    }
  });
  if (!debounceWait) {
    return {};
  }
  return {
    onCancel: () => {
      var _a;
      (_a = debouncedRef.value) == null ? void 0 : _a.cancel();
    }
  };
};
const useLoadingDelayPlugin = (fetchInstance, { loadingDelay }) => {
  const timerRef = ref();
  if (isRef(loadingDelay) ? !loadingDelay.value : !loadingDelay) {
    return {};
  }
  const cancelTimeout = () => {
    if (timerRef.value) {
      clearTimeout(timerRef.value);
    }
  };
  return {
    onBefore: () => {
      cancelTimeout();
      timerRef.value = setTimeout(() => {
        fetchInstance.setState({
          loading: true
        });
      }, isRef(loadingDelay) ? loadingDelay.value : loadingDelay);
      return {
        loading: false
      };
    },
    onFinally: () => {
      cancelTimeout();
    },
    onCancel: () => {
      cancelTimeout();
    }
  };
};
function canUseDom() {
  return !!(typeof window !== "undefined" && window.document && window.document.createElement);
}
function isDocumentVisible() {
  if (canUseDom()) {
    return document.visibilityState !== "hidden";
  }
  return true;
}
const listeners$1 = [];
function subscribe$1(listener) {
  listeners$1.push(listener);
  return function unsubscribe() {
    const index = listeners$1.indexOf(listener);
    listeners$1.splice(index, 1);
  };
}
if (canUseDom()) {
  const revalidate = () => {
    if (!isDocumentVisible())
      return;
    for (let i = 0; i < listeners$1.length; i++) {
      const listener = listeners$1[i];
      listener();
    }
  };
  window.addEventListener("visibilitychange", revalidate, false);
}
const usePollingPlugin = (fetchInstance, { pollingInterval, pollingWhenHidden = true }) => {
  const timerRef = ref();
  const unsubscribeRef = ref();
  const stopPolling = () => {
    var _a;
    if (timerRef.value) {
      clearInterval(timerRef.value);
    }
    (_a = unsubscribeRef.value) == null ? void 0 : _a.call(unsubscribeRef);
  };
  watchEffect(() => {
    if (isRef(pollingInterval) ? !(pollingInterval == null ? void 0 : pollingInterval.value) : !pollingInterval) {
      stopPolling();
    }
  });
  if (isRef(pollingInterval) ? !(pollingInterval == null ? void 0 : pollingInterval.value) : !pollingInterval) {
    return {};
  }
  return {
    onBefore: () => {
      stopPolling();
    },
    onFinally: () => {
      if (!pollingWhenHidden && !isDocumentVisible()) {
        unsubscribeRef.value = subscribe$1(() => {
          fetchInstance.refresh();
        });
        return;
      }
      timerRef.value = setInterval(() => {
        fetchInstance.refresh();
      }, isRef(pollingInterval) ? pollingInterval == null ? void 0 : pollingInterval.value : pollingInterval);
    },
    onCancel: () => {
      stopPolling();
    }
  };
};
function limit(fn, timespan) {
  let pending = false;
  return (...args) => {
    if (pending)
      return;
    pending = true;
    fn(...args);
    setTimeout(() => {
      pending = false;
    }, timespan);
  };
}
function isOnline() {
  if (canUseDom() && typeof navigator.onLine !== "undefined") {
    return navigator.onLine;
  }
  return true;
}
const listeners = [];
function subscribe(listener) {
  listeners.push(listener);
  return function unsubscribe() {
    const index = listeners.indexOf(listener);
    listeners.splice(index, 1);
  };
}
if (canUseDom()) {
  const revalidate = () => {
    if (!isDocumentVisible() || !isOnline())
      return;
    for (let i = 0; i < listeners.length; i++) {
      const listener = listeners[i];
      listener();
    }
  };
  window.addEventListener("visibilitychange", revalidate, false);
  window.addEventListener("focus", revalidate, false);
}
const useRefreshOnWindowFocusPlugin = (fetchInstance, { refreshOnWindowFocus, focusTimespan = 5e3 }) => {
  const unsubscribeRef = ref();
  const stopSubscribe = () => {
    var _a;
    (_a = unsubscribeRef.value) == null ? void 0 : _a.call(unsubscribeRef);
  };
  watchEffect((onInvalidate) => {
    if (isRef(refreshOnWindowFocus) ? refreshOnWindowFocus == null ? void 0 : refreshOnWindowFocus.value : refreshOnWindowFocus) {
      const limitRefresh = limit(fetchInstance.refresh.bind(fetchInstance), focusTimespan);
      unsubscribeRef.value = subscribe(() => {
        limitRefresh();
      });
    }
    onInvalidate(() => {
      stopSubscribe();
    });
  });
  onUnmounted(() => {
    stopSubscribe();
  });
  return {};
};
const useRetryPlugin = (fetchInstance, { retryInterval, retryCount }) => {
  const timerRef = ref();
  const countRef = ref(0);
  const triggerByRetry = ref(false);
  if (!retryCount) {
    return {};
  }
  return {
    onBefore: () => {
      if (!triggerByRetry.value) {
        countRef.value = 0;
      }
      triggerByRetry.value = false;
      if (timerRef.value) {
        clearTimeout(timerRef.value);
      }
    },
    onSuccess: () => {
      countRef.value = 0;
    },
    onError: () => {
      countRef.value += 1;
      if (retryCount === -1 || countRef.value <= retryCount) {
        const timeout = retryInterval != null ? retryInterval : Math.min(1e3 * 2 ** countRef.value, 3e4);
        timerRef.value = setTimeout(() => {
          triggerByRetry.value = true;
          fetchInstance.refresh();
        }, timeout);
      } else {
        countRef.value = 0;
      }
    },
    onCancel: () => {
      countRef.value = 0;
      if (timerRef.value) {
        clearTimeout(timerRef.value);
      }
    }
  };
};
const useThrottlePlugin = (fetchInstance, { throttleWait, throttleLeading, throttleTrailing }) => {
  const throttledRef = ref();
  const options = {};
  if ((throttleLeading == null ? void 0 : throttleLeading.value) !== void 0) {
    options.leading = throttleLeading.value;
  }
  if ((throttleTrailing == null ? void 0 : throttleTrailing.value) !== void 0) {
    options.trailing = throttleTrailing.value;
  }
  watchEffect((onInvalidate) => {
    if (throttleWait) {
      const _originRunAsync = fetchInstance.runAsync.bind(fetchInstance);
      throttledRef.value = throttle_1((callback) => {
        callback();
      }, throttleWait, options);
      fetchInstance.runAsync = (...args) => {
        return new Promise((resolve, reject) => {
          var _a;
          (_a = throttledRef.value) == null ? void 0 : _a.call(throttledRef, () => {
            _originRunAsync(...args).then(resolve).catch(reject);
          });
        });
      };
      onInvalidate(() => {
        var _a;
        fetchInstance.runAsync = _originRunAsync;
        (_a = throttledRef.value) == null ? void 0 : _a.cancel();
      });
    }
  });
  if (!throttleWait) {
    return {};
  }
  return {
    onCancel: () => {
      var _a;
      (_a = throttledRef.value) == null ? void 0 : _a.cancel();
    }
  };
};
class Fetch {
  constructor(serviceRef, options, setUpdataData, initState2 = {}) {
    __publicField(this, "pluginImpls");
    __publicField(this, "count", 0);
    __publicField(this, "state", {
      loading: false,
      params: void 0,
      data: void 0,
      error: void 0
    });
    this.serviceRef = serviceRef;
    this.options = options;
    this.setUpdataData = setUpdataData;
    this.initState = initState2;
    this.state = __spreadValues(__spreadProps(__spreadValues({}, this.state), {
      loading: !options.manual
    }), initState2);
  }
  setState(s = {}) {
    this.state = __spreadValues(__spreadValues({}, this.state), s);
    this.setUpdataData(this.state);
  }
  setData(data, key) {
    if (key instanceof Array) {
      key.forEach((k) => {
        this.state[k] = data;
        this.setUpdataData(data, k);
      });
    } else {
      this.state[key] = data;
      this.setUpdataData(data, key);
    }
  }
  runPluginHandler(event, ...rest) {
    var _a;
    const r = (_a = this.pluginImpls) == null ? void 0 : _a.map((i) => {
      var _a2;
      return (_a2 = i[event]) == null ? void 0 : _a2.call(i, ...rest);
    }).filter(Boolean);
    return Object.assign({}, ...r);
  }
  async runAsync(...params) {
    var _b, _c, _d, _e, _f, _g, _h, _i, _j, _k;
    this.count += 1;
    const currentCount = this.count;
    const _a = this.runPluginHandler("onBefore", params), {
      stopNow = false,
      returnNow = false
    } = _a, state = __objRest(_a, [
      "stopNow",
      "returnNow"
    ]);
    if (stopNow) {
      return new Promise(() => {
      });
    }
    this.setState(__spreadValues({
      loading: true,
      params
    }, state));
    if (returnNow) {
      return Promise.resolve(state.data);
    }
    (_c = (_b = this.options).onBefore) == null ? void 0 : _c.call(_b, params);
    try {
      let { servicePromise } = this.runPluginHandler("onRequest", this.serviceRef.value, params);
      if (!servicePromise) {
        servicePromise = this.serviceRef.value(...params);
      }
      const res = await servicePromise;
      if (currentCount !== this.count) {
        return new Promise(() => {
        });
      }
      this.setState({
        data: res,
        error: void 0,
        loading: false
      });
      (_e = (_d = this.options).onSuccess) == null ? void 0 : _e.call(_d, res, params);
      this.runPluginHandler("onSuccess", res, params);
      (_g = (_f = this.options).onFinally) == null ? void 0 : _g.call(_f, params, res, void 0);
      if (currentCount === this.count) {
        this.runPluginHandler("onFinally", params, res, void 0);
      }
      return res;
    } catch (error) {
      if (currentCount !== this.count) {
        return new Promise(() => {
        });
      }
      this.setState({
        error,
        loading: false
      });
      (_i = (_h = this.options).onError) == null ? void 0 : _i.call(_h, error, params);
      this.runPluginHandler("onError", error, params);
      (_k = (_j = this.options).onFinally) == null ? void 0 : _k.call(_j, params, void 0, error);
      if (currentCount === this.count) {
        this.runPluginHandler("onFinally", params, void 0, error);
      }
      throw error;
    }
  }
  run(...params) {
    this.runAsync(...params).catch((error) => {
      if (!this.options.onError) {
        console.error(error);
      }
    });
  }
  cancel() {
    this.count += 1;
    this.setState({
      loading: false
    });
    this.runPluginHandler("onCancel");
  }
  refresh() {
    this.run(...this.state.params || []);
  }
  refreshAsync() {
    return this.runAsync(...this.state.params || []);
  }
  mutate(data) {
    let targetData;
    if (typeof data === "function") {
      targetData = data == null ? void 0 : data(this.state.data);
    } else {
      targetData = data;
    }
    this.runPluginHandler("onMutate", targetData);
    this.setState({
      data: targetData
    });
  }
}
function useRequestImplement(service, options = {}, plugins = []) {
  const _a = options, { manual = false } = _a, rest = __objRest(_a, ["manual"]);
  const fetchOptions = __spreadValues({
    manual
  }, rest);
  const serviceRef = ref(service);
  const state = reactive({
    data: void 0,
    loading: true,
    params: void 0,
    error: void 0
  });
  const setState = (s, field) => {
    if (field) {
      state[field] = s;
    } else {
      state.data = s.data;
      state.loading = s.loading;
      state.error = s.error;
      state.params = s.params;
    }
  };
  const fetchInstance = computed(() => {
    const initState2 = plugins.map((p) => {
      var _a2;
      return (_a2 = p == null ? void 0 : p.onInit) == null ? void 0 : _a2.call(p, fetchOptions);
    }).filter(Boolean);
    return new Fetch(serviceRef, fetchOptions, setState, Object.assign({}, ...initState2));
  });
  fetchInstance.value.options = fetchOptions;
  fetchInstance.value.pluginImpls = plugins.map((p) => {
    return p(fetchInstance.value, fetchOptions);
  });
  onMounted(() => {
    if (!manual) {
      const params = fetchInstance.value.state.params || options.defaultParams || [];
      fetchInstance.value.run(...params);
    }
  });
  onUnmounted(() => {
    fetchInstance.value.cancel();
  });
  return __spreadProps(__spreadValues({}, toRefs(state)), {
    cancel: fetchInstance.value.cancel.bind(fetchInstance.value),
    refresh: fetchInstance.value.refresh.bind(fetchInstance.value),
    refreshAsync: fetchInstance.value.refreshAsync.bind(fetchInstance.value),
    run: fetchInstance.value.run.bind(fetchInstance.value),
    runAsync: fetchInstance.value.runAsync.bind(fetchInstance.value),
    mutate: fetchInstance.value.mutate.bind(fetchInstance.value)
  });
}
function useRequest(service, options, plugins) {
  return useRequestImplement(service, options, [
    ...plugins || [],
    useDebouncePlugin,
    useLoadingDelayPlugin,
    usePollingPlugin,
    useRefreshOnWindowFocusPlugin,
    useThrottlePlugin,
    useAutoRunPlugin,
    useCachePlugin,
    useRetryPlugin
  ]);
}
function useToggle(defaultValue = false, reverseValue) {
  const state = ref(defaultValue);
  const actions = computed(() => {
    const reverseValueOrigin = reverseValue === void 0 ? !defaultValue : reverseValue;
    const toggle = () => {
      state.value = state.value === defaultValue ? reverseValueOrigin : defaultValue;
    };
    const set = (value) => state.value = value;
    const setLeft = () => state.value = defaultValue;
    const setRight = () => state.value = reverseValueOrigin;
    return {
      toggle,
      set,
      setLeft,
      setRight
    };
  });
  return [state, __spreadValues({}, actions.value)];
}
function useBoolean(defaultValue = false) {
  const [state, { set, toggle }] = useToggle(defaultValue);
  const actions = computed(() => {
    const setTrue = () => set(true);
    const setFalse = () => set(false);
    return {
      set: (v) => set(!!v),
      setTrue,
      setFalse,
      toggle
    };
  });
  return [state, __spreadValues({}, actions.value)];
}
function isFunction$1(obj) {
  return typeof obj === "function";
}
function useCookieState(cookieKey, options = {}) {
  const defaultValue = () => {
    const cookieValue = Cookies.get(cookieKey);
    if (typeof cookieValue === "string")
      return cookieValue;
    if (isFunction$1(options.defaultValue)) {
      return options.defaultValue();
    }
    return options.defaultValue;
  };
  const state = ref(defaultValue());
  const updateState = (newValue, newOptions = {}) => {
    const _a = __spreadValues(__spreadValues({}, options), newOptions), { defaultValue: defaultValue2 } = _a, restOptions = __objRest(_a, ["defaultValue"]);
    const getValue = () => {
      const value = isFunction$1(newValue) ? newValue(state.value) : newValue;
      if (value === void 0) {
        Cookies.remove(cookieKey);
      } else {
        Cookies.set(cookieKey, value, restOptions);
      }
      return value;
    };
    state.value = getValue();
  };
  return [state, updateState];
}
const isNumber = (value) => typeof value === "number";
function getTargetValue(val, options = {}) {
  const { min, max } = options;
  let target = val;
  if (isNumber(max)) {
    target = Math.min(max, target);
  }
  if (isNumber(min)) {
    target = Math.max(min, target);
  }
  return target;
}
function useCounter(initialValue = 0, options = {}) {
  const { min, max } = options;
  const current = ref(getTargetValue(initialValue, {
    min,
    max
  }));
  const setValue = (value) => {
    const target = isNumber(value) ? value : value(current.value);
    current.value = getTargetValue(target, {
      max,
      min
    });
    return current.value;
  };
  const inc = (delta = 1) => {
    setValue((c) => c + delta);
  };
  const dec = (delta = 1) => {
    setValue((c) => c - delta);
  };
  const set = (value) => {
    setValue(value);
  };
  const reset = () => {
    setValue(initialValue);
  };
  return [
    current,
    {
      inc,
      dec,
      set,
      reset
    }
  ];
}
function useDebounceFn(fn, options) {
  var _a;
  const wait = (_a = options == null ? void 0 : options.wait) != null ? _a : 1e3;
  const run = debounce_1(fn, wait, options);
  return {
    run
  };
}
function useDebounce(value, options) {
  const debounced = ref(value.value);
  const { run } = useDebounceFn(() => debounced.value = value.value, options);
  watch(value, () => run(), { deep: true });
  return debounced;
}
const isBrowser = !!(typeof window !== "undefined" && window.document && window.document.createElement);
function getTargetElement(target, defaultElement) {
  if (!isBrowser) {
    return void 0;
  }
  if (!target) {
    return defaultElement;
  }
  let targetElement;
  if (typeof target === "function") {
    targetElement = target();
  } else if (isRef(target)) {
    targetElement = target.value;
  } else {
    targetElement = target;
  }
  return targetElement;
}
function depsAreSame(oldDeps, deps) {
  if (oldDeps === deps)
    return true;
  for (let i = 0; i < oldDeps.length; i++) {
    if (!Object.is(oldDeps[i], deps[i]))
      return false;
  }
  return true;
}
const createEffectWithTarget = (useEffectType) => {
  const useEffectWithTarget2 = (effect, deps, target) => {
    const hasInitRef = ref(false);
    const lastElementRef = ref([]);
    const lastDepsRef = ref([]);
    const unLoadRef = ref();
    useEffectType(() => {
      var _a;
      const targets = Array.isArray(target) ? target : [target];
      const els = targets.map((item) => getTargetElement(item));
      if (!hasInitRef.value) {
        hasInitRef.value = true;
        lastElementRef.value = els;
        lastDepsRef.value = deps;
        unLoadRef.value = effect();
        return;
      }
      if (els.length !== lastElementRef.value.length || !depsAreSame(els, lastElementRef.value) || !depsAreSame(deps, lastDepsRef.value)) {
        (_a = unLoadRef.value) == null ? void 0 : _a.call(unLoadRef);
        lastElementRef.value = els;
        lastDepsRef.value = deps;
        unLoadRef.value = effect();
      }
    });
    onUnmounted(() => {
      var _a;
      (_a = unLoadRef.value) == null ? void 0 : _a.call(unLoadRef);
      hasInitRef.value = false;
    });
  };
  return useEffectWithTarget2;
};
const useEffectWithTarget = createEffectWithTarget(watchEffect);
const useDrag = (data, target, options = {}) => {
  const optionsRef = ref(options);
  useEffectWithTarget(() => {
    const targetElement = getTargetElement(target);
    if (!(targetElement == null ? void 0 : targetElement.addEventListener)) {
      return;
    }
    const onDragStart = (event) => {
      var _a, _b, _c;
      (_b = (_a = optionsRef.value).onDragStart) == null ? void 0 : _b.call(_a, event);
      (_c = event.dataTransfer) == null ? void 0 : _c.setData("custom", JSON.stringify(data));
    };
    const onDragEnd = (event) => {
      var _a, _b;
      (_b = (_a = optionsRef.value).onDragEnd) == null ? void 0 : _b.call(_a, event);
    };
    targetElement.setAttribute("draggable", `${(options == null ? void 0 : options.draggable) !== void 0 ? options == null ? void 0 : options.draggable : true}`);
    targetElement.addEventListener("dragstart", onDragStart);
    targetElement.addEventListener("dragend", onDragEnd);
    return () => {
      targetElement.removeEventListener("dragstart", onDragStart);
      targetElement.removeEventListener("dragend", onDragEnd);
    };
  }, [], target);
};
const useDrop = (target, options = {}) => {
  const optionsRef = ref(options);
  const dragEnterTarget = ref();
  useEffectWithTarget(() => {
    const targetElement = getTargetElement(target);
    if (!(targetElement == null ? void 0 : targetElement.addEventListener)) {
      return;
    }
    const onData = (dataTransfer, event) => {
      const uri = dataTransfer.getData("text/uri-list");
      const dom = dataTransfer.getData("custom");
      if (dom && optionsRef.value.onDom) {
        let data = dom;
        try {
          data = JSON.parse(dom);
        } catch (e) {
          data = dom;
        }
        optionsRef.value.onDom(data, event);
        return;
      }
      if (uri && optionsRef.value.onUri) {
        optionsRef.value.onUri(uri, event);
        return;
      }
      if (dataTransfer.files && dataTransfer.files.length && optionsRef.value.onFiles) {
        optionsRef.value.onFiles(Array.from(dataTransfer.files), event);
        return;
      }
      if (dataTransfer.items && dataTransfer.items.length && optionsRef.value.onText) {
        dataTransfer.items[0].getAsString((text) => {
          optionsRef.value.onText(text, event);
        });
      }
    };
    const onDragEnter = (event) => {
      var _a, _b;
      event.preventDefault();
      event.stopPropagation();
      dragEnterTarget.value = event.target;
      (_b = (_a = optionsRef.value).onDragEnter) == null ? void 0 : _b.call(_a, event);
    };
    const onDragOver = (event) => {
      var _a, _b;
      event.preventDefault();
      (_b = (_a = optionsRef.value).onDragOver) == null ? void 0 : _b.call(_a, event);
    };
    const onDragLeave = (event) => {
      var _a, _b;
      if (event.target === dragEnterTarget.value) {
        (_b = (_a = optionsRef.value).onDragLeave) == null ? void 0 : _b.call(_a, event);
      }
    };
    const onDrop = (event) => {
      var _a, _b;
      event.preventDefault();
      onData(event.dataTransfer, event);
      (_b = (_a = optionsRef.value).onDrop) == null ? void 0 : _b.call(_a, event);
    };
    const onPaste = (event) => {
      var _a, _b;
      onData(event.clipboardData, event);
      (_b = (_a = optionsRef.value).onPaste) == null ? void 0 : _b.call(_a, event);
    };
    targetElement.addEventListener("dragenter", onDragEnter);
    targetElement.addEventListener("dragover", onDragOver);
    targetElement.addEventListener("dragleave", onDragLeave);
    targetElement.addEventListener("drop", onDrop);
    targetElement.addEventListener("paste", onPaste);
    return () => {
      targetElement.removeEventListener("dragenter", onDragEnter);
      targetElement.removeEventListener("dragover", onDragOver);
      targetElement.removeEventListener("dragleave", onDragLeave);
      targetElement.removeEventListener("drop", onDrop);
      targetElement.removeEventListener("paste", onPaste);
    };
  }, [], target);
};
function useMedia(queries, values, defaultValue) {
  const mediaQueryLists = queries.map((q) => window.matchMedia(q));
  const getValue = () => {
    const index = mediaQueryLists.findIndex((mql) => mql.matches);
    return typeof values[index] !== "undefined" ? values[index] : defaultValue;
  };
  const value = ref(getValue());
  const handler = () => {
    value.value = getValue();
  };
  watchEffect((onInvalidate) => {
    mediaQueryLists.forEach((mql) => {
      mql.addListener(handler);
    });
    onInvalidate(() => {
      mediaQueryLists.forEach((mql) => mql.removeListener(handler));
    });
  });
  return value;
}
function useDarkMode() {
  const [enabledState, setEnabledState] = useLocalStorageState("dark-mode-enabled");
  const prefersDarkMode = usePrefersDarkMode();
  const enabled = computed(() => {
    return typeof enabledState.value !== "undefined" ? enabledState.value : prefersDarkMode.value;
  });
  watchEffect(() => {
    const className = "dark-mode";
    const element = window.document.body;
    if (enabled.value) {
      element.classList.add(className);
    } else {
      element.classList.remove(className);
    }
  });
  return [enabled, setEnabledState];
}
function usePrefersDarkMode() {
  return useMedia(["(prefers-color-scheme: dark)"], [true], false);
}
function useEventListener(eventName, handler, options = {}) {
  const handlerRef = ref(handler);
  useEffectWithTarget(() => {
    const targetElement = getTargetElement(options.target, window);
    if (!(targetElement == null ? void 0 : targetElement.addEventListener)) {
      return;
    }
    const eventListener = (event) => {
      return handlerRef.value(event);
    };
    targetElement.addEventListener(eventName, eventListener, {
      capture: options.capture,
      once: options.once,
      passive: options.passive
    });
    return () => {
      targetElement.removeEventListener(eventName, eventListener, {
        capture: options.capture
      });
    };
  }, [eventName, options.capture, options.once, options.passive], options.target);
}
function useEcharts(options) {
  const { defaultOptions } = options != null ? options : {};
  const container = ref(null);
  const chart = ref();
  const optionsRef = ref(defaultOptions);
  onMounted(() => {
    if (!container.value) {
      return;
    }
    const myEcharts = init(container.value);
    chart.value = myEcharts;
  });
  watchEffect(() => {
    var _a;
    if (optionsRef.value && chart.value) {
      (_a = chart.value) == null ? void 0 : _a.setOption(optionsRef.value);
    }
  });
  onUnmounted(() => {
    var _a, _b, _c, _d;
    (_b = (_a = chart.value) == null ? void 0 : _a.dispose) == null ? void 0 : _b.call(_a);
    (_d = (_c = chart.value) == null ? void 0 : _c.off) == null ? void 0 : _d.call(_c, "*");
    chart.value = void 0;
  });
  useEventListener("resize", () => {
    requestAnimationFrame(() => {
      var _a, _b;
      (_b = (_a = chart == null ? void 0 : chart.value) == null ? void 0 : _a.resize) == null ? void 0 : _b.call(_a);
    });
  });
  return { chart, container };
}
const EXTERNAL_USED_COUNT = {};
const loadScript = (path, props = {}) => {
  const script = document.querySelector(`script[src="${path}"]`);
  if (!script) {
    const newScript = document.createElement("script");
    newScript.src = path;
    Object.keys(props).forEach((key) => {
      newScript[key] = props[key];
    });
    newScript.setAttribute("data-status", "loading");
    document.body.appendChild(newScript);
    return {
      ref: newScript,
      status: "loading"
    };
  }
  return {
    ref: script,
    status: script.getAttribute("data-status") || "ready"
  };
};
const loadCss = (path, props = {}) => {
  const css = document.querySelector(`link[href="${path}"]`);
  if (!css) {
    const newCss = document.createElement("link");
    newCss.rel = "stylesheet";
    newCss.href = path;
    Object.keys(props).forEach((key) => {
      newCss[key] = props[key];
    });
    const isLegacyIECss = "hideFocus" in newCss;
    if (isLegacyIECss && newCss.relList) {
      newCss.rel = "preload";
      newCss.as = "style";
    }
    newCss.setAttribute("data-status", "loading");
    document.head.appendChild(newCss);
    return {
      ref: newCss,
      status: "loading"
    };
  }
  return {
    ref: css,
    status: css.getAttribute("data-status") || "ready"
  };
};
function useExternal(path, options) {
  const status = ref(path ? "loading" : "unset");
  const hookRef = ref();
  const path_ = computed(() => isRef(path) ? path.value : path);
  watchEffect((onInvalidate) => {
    var _a, _b, _c, _d;
    if (!path_.value) {
      status.value = "unset";
      return;
    }
    const pathname = (_b = (_a = path_.value) == null ? void 0 : _a.replace(/[|#].*$/, "")) != null ? _b : "";
    if ((options == null ? void 0 : options.type) === "css" || !(options == null ? void 0 : options.type) && /(^css!|\.css$)/.test(pathname)) {
      const result = loadCss((_c = path_.value) != null ? _c : "", options == null ? void 0 : options.css);
      hookRef.value = result.ref;
      status.value = result.status;
    } else if ((options == null ? void 0 : options.type) === "js" || !(options == null ? void 0 : options.type) && /(^js!|\.js$)/.test(pathname)) {
      const result = loadScript((_d = path_.value) != null ? _d : "", options == null ? void 0 : options.js);
      hookRef.value = result.ref;
      status.value = result.status;
    } else {
      console.error("Cannot infer the type of external resource, and please provide a type ('js' | 'css'). Refer to the https://ahooks.js.org/hooks/dom/use-external/#options");
    }
    if (!hookRef.value) {
      return;
    }
    if (path_.value && EXTERNAL_USED_COUNT[path_.value] === void 0) {
      EXTERNAL_USED_COUNT[path_.value] = 1;
    } else {
      if (path_.value)
        EXTERNAL_USED_COUNT[path_.value] += 1;
    }
    const handler = (event) => {
      var _a2;
      const targetStatus = event.type === "load" ? "ready" : "error";
      (_a2 = hookRef.value) == null ? void 0 : _a2.setAttribute("data-status", targetStatus);
      status.value = targetStatus;
    };
    hookRef.value.addEventListener("load", handler);
    hookRef.value.addEventListener("error", handler);
    onInvalidate(() => {
      var _a2, _b2, _c2;
      (_a2 = hookRef.value) == null ? void 0 : _a2.removeEventListener("load", handler);
      (_b2 = hookRef.value) == null ? void 0 : _b2.removeEventListener("error", handler);
      if (path_.value)
        EXTERNAL_USED_COUNT[path_.value] -= 1;
      if (path_.value && EXTERNAL_USED_COUNT[path_.value] === 0) {
        (_c2 = hookRef.value) == null ? void 0 : _c2.remove();
      }
      hookRef.value = void 0;
    });
  });
  return status;
}
class EventEmitter {
  constructor() {
    __publicField(this, "subscriptions", /* @__PURE__ */ new Map());
    __publicField(this, "emitEffectCache", /* @__PURE__ */ new Map());
    __publicField(this, "useSubscription", (event, listener) => {
      const callbackRef = ref();
      watchEffect((onInvalidate) => {
        var _a, _b;
        callbackRef.value = listener;
        function subscription(val) {
          if (callbackRef.value) {
            callbackRef.value(val);
          }
        }
        const subscriptions = (_b = (_a = this.subscriptions) == null ? void 0 : _a.get(event)) != null ? _b : [];
        subscriptions.push(subscription);
        this.subscriptions.set(event, subscriptions);
        this.emitEffect(event);
        onInvalidate(() => {
          this.subscriptions.delete(event);
        });
      });
    });
    __publicField(this, "emit", (event, ...args) => {
      if (typeof event === "string" || typeof event === "number") {
        const subscriptionValuesCallback = this.subscriptions.get(event);
        subscriptionValuesCallback == null ? void 0 : subscriptionValuesCallback.forEach((callback) => {
          callback == null ? void 0 : callback({
            params: lodash.exports.cloneDeep(args),
            event
          });
        });
        this.emitEffectCache.set(event, {
          params: lodash.exports.cloneDeep(args),
          event
        });
      } else
        throw new TypeError("event must be string or number !");
    });
    __publicField(this, "emitEffect", (event) => {
      const emitEffectCache = this.emitEffectCache.get(event);
      const listeners2 = this.subscriptions.get(event);
      if (emitEffectCache)
        listeners2 == null ? void 0 : listeners2.forEach((listener) => {
          listener == null ? void 0 : listener(__spreadValues({}, emitEffectCache));
        });
    });
    __publicField(this, "removeListener", (event) => {
      this.subscriptions.delete(event);
    });
    __publicField(this, "clear", () => {
      this.subscriptions.clear();
    });
    this.clear();
  }
}
const eventEmitterOverall = new EventEmitter();
function useEventEmitter(options) {
  const eventRef = ref();
  const eventEmitterOptions = computed(() => options != null ? options : { global: false });
  if (!eventRef.value) {
    eventRef.value = eventEmitterOptions.value.global ? eventRef.value = eventEmitterOverall : eventRef.value = new EventEmitter();
  }
  watchEffect((onInvalidate) => {
    onInvalidate(() => {
      var _a;
      return (_a = eventRef.value) == null ? void 0 : _a.clear();
    });
  });
  return eventRef.value;
}
const ImgTypeMap = {
  SVG: "image/svg+xml",
  ICO: "image/x-icon",
  GIF: "image/gif",
  PNG: "image/png"
};
function useFavicon(href) {
  const _href = computed(() => isRef(href) ? href.value : href);
  watchEffect(() => {
    var _a;
    if (!_href.value)
      return;
    const cutUrl = (_a = _href.value) == null ? void 0 : _a.split(".");
    const imgSuffix = cutUrl[cutUrl.length - 1].toLocaleUpperCase();
    const link = document.querySelector("link[rel*='icon']") || document.createElement("link");
    link.type = ImgTypeMap[imgSuffix];
    link.href = _href.value;
    link.rel = "shortcut icon";
    document.getElementsByTagName("head")[0].appendChild(link);
  });
}
function useFocusWithin(target, options) {
  const [isFocusWithin, { set: setIsFocusWithin }] = useBoolean(false);
  const { onFocus, onBlur, onChange } = options || {};
  useEventListener("focusin", (e) => {
    if (!isFocusWithin.value) {
      onFocus == null ? void 0 : onFocus(e);
      onChange == null ? void 0 : onChange(true);
      setIsFocusWithin(true);
    }
  }, {
    target
  });
  useEventListener("focusout", (e) => {
    var _a, _b;
    if (isFocusWithin.value && !((_b = (_a = e.currentTarget) == null ? void 0 : _a.contains) == null ? void 0 : _b.call(_a, e.relatedTarget))) {
      onBlur == null ? void 0 : onBlur(e);
      onChange == null ? void 0 : onChange(false);
      setIsFocusWithin(false);
    }
  }, {
    target
  });
  return isFocusWithin;
}
function useHover(target, options) {
  const { onEnter, onLeave } = options || {};
  const [state, { setTrue, setFalse }] = useBoolean(false);
  useEventListener("mouseenter", () => {
    onEnter == null ? void 0 : onEnter();
    setTrue();
  }, {
    target
  });
  useEventListener("mouseleave", () => {
    onLeave == null ? void 0 : onLeave();
    setFalse();
  }, {
    target
  });
  return state;
}
function useInterval(fn, delay, options) {
  const immediate = options == null ? void 0 : options.immediate;
  const fnRef = ref(fn);
  watchEffect((onInvalidate) => {
    if (isRef(delay)) {
      if (typeof delay.value !== "number" || delay.value < 0)
        return;
    } else {
      if (typeof delay !== "number" || delay < 0)
        return;
    }
    if (immediate) {
      fnRef.value();
    }
    const _deply = isRef(delay) ? delay.value : delay;
    const timer = setInterval(() => {
      fnRef.value();
    }, _deply);
    onInvalidate(() => {
      clearInterval(timer);
    });
  });
}
const getScrollTop = (el) => {
  if (el === document || el === document.body) {
    return Math.max(window.pageYOffset, document.documentElement.scrollTop, document.body.scrollTop);
  }
  return el.scrollTop;
};
const getScrollHeight = (el) => {
  return el.scrollHeight || Math.max(document.documentElement.scrollHeight, document.body.scrollHeight);
};
const getClientHeight = (el) => {
  return el.clientHeight || Math.max(document.documentElement.clientHeight, document.body.clientHeight);
};
const useInfiniteScroll = (service, options = {}) => {
  const {
    target,
    isNoMore,
    threshold = 100,
    reloadDeps = [],
    manual,
    onBefore,
    onSuccess,
    onError,
    onFinally
  } = options;
  const finalData = ref();
  const [loadingMore, { set: setLoadingMore }] = useBoolean();
  const setFinalData = (mutateData) => {
    finalData.value = mutateData;
  };
  const noMore = computed(() => {
    if (!isNoMore)
      return false;
    return isNoMore(finalData.value);
  });
  const { loading, run, runAsync, cancel } = useRequest(async (lastData) => {
    const currentData = await service(lastData);
    if (!lastData) {
      finalData.value = currentData;
    } else {
      finalData.value = __spreadProps(__spreadValues({}, currentData), {
        list: [...lastData.list, ...currentData.list]
      });
    }
    console.log(currentData);
    return currentData;
  }, {
    manual,
    onFinally: (_, d, e) => {
      setLoadingMore(false);
      onFinally == null ? void 0 : onFinally(d, e);
    },
    onBefore: () => onBefore == null ? void 0 : onBefore(),
    onSuccess: (d) => {
      setTimeout(() => {
        scrollMethod();
      });
      onSuccess == null ? void 0 : onSuccess(d);
    },
    onError: (e) => onError == null ? void 0 : onError(e)
  });
  const loadMore = () => {
    if (noMore.value)
      return;
    setLoadingMore(true);
    run(finalData.value);
  };
  const loadMoreAsync = () => {
    if (noMore)
      return;
    setLoadingMore(true);
    return runAsync(finalData.value);
  };
  const reload = () => run();
  const reloadAsync = () => runAsync();
  const scrollMethod = () => {
    const el = getTargetElement(target);
    if (!el) {
      return;
    }
    const scrollTop = getScrollTop(el);
    const scrollHeight = getScrollHeight(el);
    const clientHeight = getClientHeight(el);
    if (scrollHeight - scrollTop <= clientHeight + threshold) {
      loadMore();
    }
  };
  useEventListener("scroll", () => {
    if (loading.value || loadingMore.value) {
      return;
    }
    scrollMethod();
  }, { target });
  watch([...reloadDeps], () => {
    run();
  });
  const _loading = computed(() => loadingMore.value && loading.value);
  return {
    data: finalData,
    loading: _loading,
    loadingMore,
    noMore,
    loadMore,
    loadMoreAsync,
    reload,
    reloadAsync,
    mutate: setFinalData,
    scrollMethod,
    cancel
  };
};
function isFunction(obj) {
  return typeof obj === "function";
}
function createUseStorageState(getStorage) {
  function useStorageState(key, options) {
    let storage;
    try {
      storage = getStorage();
    } catch (err) {
      console.error(err);
    }
    const serializer = (value) => {
      if (options == null ? void 0 : options.serializer) {
        return options == null ? void 0 : options.serializer(value);
      }
      return JSON.stringify(value);
    };
    const deserializer = (value) => {
      if (options == null ? void 0 : options.deserializer) {
        return options == null ? void 0 : options.deserializer(value);
      }
      return JSON.parse(value);
    };
    function getStoredValue() {
      try {
        const raw = storage == null ? void 0 : storage.getItem(isRef(key) ? key.value : key);
        if (raw) {
          return deserializer(raw);
        }
      } catch (e) {
        console.error(e);
      }
      if (isFunction(options == null ? void 0 : options.defaultValue)) {
        return options == null ? void 0 : options.defaultValue();
      }
      return options == null ? void 0 : options.defaultValue;
    }
    const state = ref(getStoredValue());
    watchEffect(() => {
      if (key)
        state.value = getStoredValue();
    });
    const updateState = (value) => {
      if (typeof value === "undefined") {
        state.value = void 0;
        storage == null ? void 0 : storage.removeItem(isRef(key) ? key.value : key);
      } else if (isFunction(value)) {
        const currentState = value(state.value);
        try {
          state.value = currentState;
          storage == null ? void 0 : storage.setItem(isRef(key) ? key.value : key, serializer(currentState));
        } catch (e) {
          console.error(e);
        }
      } else {
        try {
          state.value = value;
          storage == null ? void 0 : storage.setItem(isRef(key) ? key.value : key, serializer(value));
        } catch (e) {
          console.error(e);
        }
      }
    };
    return [state, updateState];
  }
  return useStorageState;
}
const useLocalStorageState = createUseStorageState(() => isBrowser ? localStorage : void 0);
function useLockFn(fn) {
  const lockRef = ref(false);
  return async (...args) => {
    if (lockRef.value)
      return;
    lockRef.value = true;
    try {
      const ret = await fn(...args);
      lockRef.value = false;
      return ret;
    } catch (e) {
      lockRef.value = false;
      throw e;
    }
  };
}
const initState = {
  screenX: NaN,
  screenY: NaN,
  clientX: NaN,
  clientY: NaN,
  pageX: NaN,
  pageY: NaN,
  elementX: NaN,
  elementY: NaN,
  elementH: NaN,
  elementW: NaN,
  elementPosX: NaN,
  elementPosY: NaN
};
function useMouse(target) {
  const state = ref(initState);
  console.log(target);
  useEventListener("mousemove", (event) => {
    const { screenX, screenY, clientX, clientY, pageX, pageY } = event;
    const newState = {
      screenX,
      screenY,
      clientX,
      clientY,
      pageX,
      pageY,
      elementX: NaN,
      elementY: NaN,
      elementH: NaN,
      elementW: NaN,
      elementPosX: NaN,
      elementPosY: NaN
    };
    const targetElement = getTargetElement(target);
    if (targetElement) {
      const { left, top, width, height } = targetElement.getBoundingClientRect();
      newState.elementPosX = left + window.pageXOffset;
      newState.elementPosY = top + window.pageYOffset;
      newState.elementX = pageX - newState.elementPosX;
      newState.elementY = pageY - newState.elementPosY;
      newState.elementW = width;
      newState.elementH = height;
    }
    state.value = newState;
  }, {
    target: document
  });
  return state;
}
function useMap(initialValue) {
  const initialMap = initialValue ? new Map(initialValue) : /* @__PURE__ */ new Map();
  const state = ref(initialMap);
  const actions = {
    set: (key, value) => {
      state.value.set(key, value);
    },
    get: (key) => {
      return state.value.get(key);
    },
    remove: (key) => {
      state.value.delete(key);
    },
    has: (key) => state.value.has(key),
    clear: () => state.value.clear(),
    setAll: (newMap) => {
      state.value = new Map(newMap);
    },
    reset: () => state.value = initialMap
  };
  return [state, markRaw(actions)];
}
function getConnection() {
  const nav = navigator;
  if (typeof nav !== "object")
    return null;
  return nav.connection || nav.mozConnection || nav.webkitConnection;
}
function getConnectionProperty() {
  const c = getConnection();
  if (!c)
    return {};
  return {
    rtt: c.rtt,
    type: c.type,
    saveData: c.saveData,
    downlink: c.downlink,
    downlinkMax: c.downlinkMax,
    effectiveType: c.effectiveType
  };
}
function useNetwork() {
  const state = ref(__spreadValues({
    since: void 0,
    online: navigator == null ? void 0 : navigator.onLine
  }, getConnectionProperty()));
  watchEffect((onInvalidate) => {
    const onOnline = () => {
      state.value = __spreadProps(__spreadValues({}, state.value), {
        online: true,
        since: new Date()
      });
    };
    const onOffline = () => {
      state.value = __spreadProps(__spreadValues({}, state.value), {
        online: false,
        since: new Date()
      });
    };
    const onConnectionChange = () => {
      state.value = __spreadValues(__spreadValues({}, state.value), getConnectionProperty());
    };
    window.addEventListener("online", onOnline);
    window.addEventListener("offline", onOffline);
    const connection = getConnection();
    connection == null ? void 0 : connection.addEventListener("change", onConnectionChange);
    onInvalidate(() => {
      window.removeEventListener("online", onOnline);
      window.removeEventListener("offline", onOffline);
      connection == null ? void 0 : connection.removeEventListener("change", onConnectionChange);
    });
  });
  return state.value;
}
const useSessionStorageState = createUseStorageState(() => isBrowser ? sessionStorage : void 0);
function useSet(initialValue) {
  const initialSet = initialValue ? new Set(initialValue) : /* @__PURE__ */ new Set();
  const state = ref(initialSet);
  const actions = {
    add: (value) => {
      state.value.add(value);
    },
    remove: (value) => {
      state.value.delete(value);
    },
    has: (value) => state.value.has(value),
    clear: () => state.value.clear(),
    reset: () => {
      state.value = /* @__PURE__ */ new Set();
    }
  };
  return [state, markRaw(actions)];
}
function useWinResize(Action = () => {
}) {
  const fn = () => {
    nextTick(() => {
      Action();
    });
  };
  onMounted(() => {
    window.addEventListener("resize", fn, false);
  });
  onBeforeUnmount(() => {
    window.removeEventListener("resize", fn);
  });
  return null;
}
function useSize(target) {
  const size = reactive({
    width: 0,
    height: 0
  });
  const getSizeInfo = () => {
    var _a, _b;
    const targetDom = getTargetElement(target);
    size.width = (_a = targetDom == null ? void 0 : targetDom.clientWidth) != null ? _a : 0;
    size.height = (_b = targetDom == null ? void 0 : targetDom.clientHeight) != null ? _b : 0;
  };
  useWinResize(getSizeInfo);
  onMounted(() => {
    setTimeout(() => {
      getSizeInfo();
    }, 120);
  });
  return __spreadValues({}, toRefs(size));
}
function useScroll(target, shouldUpdate = () => true) {
  const position = ref();
  const shouldUpdateRef = ref(shouldUpdate);
  useEffectWithTarget(() => {
    const el = getTargetElement(target, document);
    if (!el) {
      return;
    }
    const updatePosition = () => {
      let newPosition;
      if (el === document) {
        if (document.scrollingElement) {
          newPosition = {
            left: document.scrollingElement.scrollLeft,
            top: document.scrollingElement.scrollTop
          };
        } else {
          newPosition = {
            left: Math.max(window.pageYOffset, document.documentElement.scrollTop, document.body.scrollTop),
            top: Math.max(window.pageXOffset, document.documentElement.scrollLeft, document.body.scrollLeft)
          };
        }
      } else {
        newPosition = {
          left: el.scrollLeft,
          top: el.scrollTop
        };
      }
      if (shouldUpdateRef.value(newPosition)) {
        position.value = newPosition;
      }
    };
    updatePosition();
    el.addEventListener("scroll", updatePosition);
    return () => {
      el.removeEventListener("scroll", updatePosition);
    };
  }, [], target);
  return position;
}
function useThrottleFn(fn, options) {
  var _a;
  const fnRef = ref(fn);
  const wait = (_a = options == null ? void 0 : options.wait) != null ? _a : 1e3;
  const throttled = computed(() => throttle_1((...args) => {
    return fnRef.value([...args]);
  }, wait, options));
  onUnmounted(() => {
    throttled.value.cancel();
  });
  return {
    run: throttled,
    cancel: throttled.value.cancel,
    flush: throttled.value.flush
  };
}
function useThrottle(value, options) {
  const throttled = ref();
  const { run } = useThrottleFn(() => {
    throttled.value = value.value;
  }, options);
  watch(value, () => {
    run.value();
  });
  return throttled;
}
function useTimeout(fn, delay, options) {
  const immediate = options == null ? void 0 : options.immediate;
  const fnRef = ref(fn);
  watchEffect((onInvalidate) => {
    if (isRef(delay)) {
      if (typeof delay.value !== "number" || delay.value < 0)
        return;
    } else {
      if (typeof delay !== "number" || delay < 0)
        return;
    }
    if (immediate) {
      fnRef.value();
    }
    const _deply = isRef(delay) ? delay.value : delay;
    const timer = setTimeout(() => {
      fnRef.value();
    }, _deply);
    onInvalidate(() => {
      clearInterval(timer);
    });
  });
}
const DEFAULT_OPTIONS = {
  restoreOnUnmount: false
};
function useTitle(title, options = DEFAULT_OPTIONS) {
  const titleRef = ref(isBrowser ? document.title : "");
  watch(title, () => {
    document.title = title.value;
  });
  onMounted(() => {
    document.title = title.value;
  });
  onUnmounted(() => {
    if (options.restoreOnUnmount) {
      document.title = titleRef.value;
    }
  });
}
const diffTwoDeps = (deps1, deps2) => {
  return deps1 ? deps1.map((_ele, idx) => deps1[idx] !== (deps2 == null ? void 0 : deps2[idx]) ? idx : -1).filter((ele) => ele >= 0) : deps2 ? deps2.map((_ele, idx) => idx) : [];
};
const useTrackedEffect = (effect, deps) => {
  watch(deps != null ? deps : [], (curr, prev) => {
    const changes = diffTwoDeps(prev, curr);
    effect(changes);
  });
};
function useUpdate() {
  const update = ref({});
  const setUpdate = () => {
    update.value = Object.assign({}, __spreadValues({}, update.value));
  };
  return {
    update,
    setUpdate
  };
}
const baseParseConfig = {
  parseNumbers: false,
  parseBooleans: false
};
const baseStringifyConfig = {
  skipNull: false,
  skipEmptyString: false
};
const routerPushFn = (s) => location.hash = s;
const useUrlState = (initialState, options) => {
  const { parseOptions, stringifyOptions } = options || {};
  const mergedParseOptions = __spreadValues(__spreadValues({}, baseParseConfig), parseOptions);
  const mergedStringifyOptions = __spreadValues(__spreadValues({}, baseStringifyConfig), stringifyOptions);
  const initialStateRef = ref(typeof initialState === "function" ? initialState() : initialState || {});
  const state = ref(initialStateRef.value);
  const [path] = location.hash.slice(1).split("?");
  const queryFromUrl = computed(() => {
    return queryString.parse(location.search, mergedParseOptions);
  });
  const targetQuery = computed(() => __spreadValues(__spreadValues({}, initialStateRef.value), queryFromUrl.value));
  watchEffect(() => {
    state.value = __spreadValues(__spreadValues({}, initialStateRef.value), queryFromUrl.value);
  });
  const setState = (s) => {
    const newQuery = typeof s === "function" ? s(__spreadValues(__spreadValues({}, targetQuery.value), state.value)) : s;
    state.value = __spreadValues(__spreadValues({}, state.value), newQuery);
  };
  watch(state, (curr) => {
    routerPushFn(`${path}?${queryString.stringify(__spreadValues(__spreadValues(__spreadValues({}, initialStateRef.value), queryFromUrl.value), curr), mergedStringifyOptions)}`);
  });
  return { state, setState };
};
const useVirtualList = (list, options) => {
  const containerTarget = ref();
  const { wrapperTarget, itemHeight, overscan = 5 } = options;
  const size = useSize(containerTarget);
  const targetList = ref([]);
  const scrollTriggerByScrollToFunc = ref(false);
  const getVisibleCount = (containerHeight, fromIndex) => {
    if (typeof itemHeight === "number") {
      return Math.ceil(containerHeight / itemHeight);
    }
    let sum = 0;
    let endIndex = 0;
    for (let i = fromIndex; i < list.value.length; i++) {
      const height = itemHeight(i, list.value[i]);
      sum += height;
      endIndex = i;
      if (sum >= containerHeight) {
        break;
      }
    }
    return endIndex - fromIndex;
  };
  const getOffset = (scrollTop) => {
    if (typeof itemHeight === "number") {
      return Math.floor(scrollTop / itemHeight) + 1;
    }
    let sum = 0;
    let offset = 0;
    for (let i = 0; i < list.value.length; i++) {
      const height = itemHeight(i, list.value[i]);
      sum += height;
      if (sum >= scrollTop) {
        offset = i;
        break;
      }
    }
    return offset + 1;
  };
  const getDistanceTop = (index) => {
    var _a, _b;
    if (typeof itemHeight === "number") {
      const height2 = index * itemHeight;
      return height2;
    }
    const height = (_b = (_a = list.value) == null ? void 0 : _a.slice(0, index)) == null ? void 0 : _b.reduce((sum, _, i) => sum + (itemHeight == null ? void 0 : itemHeight(i, list == null ? void 0 : list.value[index])), 0);
    return height;
  };
  const totalHeight = computed(() => {
    if (typeof itemHeight === "number") {
      return list.value.length * itemHeight;
    }
    return list.value.reduce((sum, _, index) => sum + (itemHeight == null ? void 0 : itemHeight(index, list == null ? void 0 : list.value[index])), 0);
  });
  const calculateRange = () => {
    const container2 = getTargetElement(containerTarget);
    const wrapper = getTargetElement(wrapperTarget);
    if (container2 && wrapper) {
      const { scrollTop, clientHeight } = container2;
      const offset = getOffset(scrollTop);
      const visibleCount = getVisibleCount(clientHeight, offset);
      const start = Math.max(0, offset - overscan);
      const end = Math.min(list.value.length, offset + visibleCount + overscan);
      const offsetTop = getDistanceTop(start);
      wrapper.style.height = totalHeight.value - offsetTop + "px";
      wrapper.style.marginTop = offsetTop + "px";
      targetList.value = list.value.slice(start, end).map((ele, index) => ({
        data: ele,
        index: index + start
      }));
    }
  };
  watch([size == null ? void 0 : size.width, size == null ? void 0 : size.height, list], () => {
    calculateRange();
  });
  const scrollTo = (index) => {
    const container2 = getTargetElement(containerTarget);
    if (container2) {
      scrollTriggerByScrollToFunc.value = true;
      container2.scrollTop = getDistanceTop(index);
      calculateRange();
    }
  };
  const container = reactive({
    ref: (ele) => {
      containerTarget.value = ele;
    },
    onScroll: (e) => {
      if (scrollTriggerByScrollToFunc.value) {
        scrollTriggerByScrollToFunc.value = false;
        return;
      }
      e.preventDefault();
      calculateRange();
    }
  });
  return [targetList, container, scrollTo];
};
function useWhyDidYouUpdate(componentName, props) {
  const keys = computed(() => Object.keys(props).map((key) => key));
  watch(Object.keys(props).map((key) => props[key]), (curr, prev) => {
    const changedProps = {};
    keys.value.forEach((key, index) => {
      if (prev[index] !== curr[index]) {
        changedProps[key] = {
          from: prev[index],
          to: curr[index]
        };
      }
    });
    if (Object.keys(changedProps).length) {
      console.log("[why-did-you-update]", componentName, changedProps);
    }
  }, {
    deep: true
  });
}
export { useAsyncOrder, useBoolean, useCookieState, useCounter, useDarkMode, useDebounce, useDebounceFn, useDrag, useDrop, useEcharts, useEventEmitter, useEventListener, useExternal, useFavicon, useFocusWithin, useHover, useInfiniteScroll, useInterval, useLocalStorageState, useLockFn, useMap, useMedia, useMouse, useNetwork, useRequest, useScroll, useSessionStorageState, useSet, useSize, useThrottle, useThrottleFn, useTimeout, useTitle, useToggle, useTrackedEffect, useUpdate, useUrlState, useVirtualList, useWhyDidYouUpdate, useWinResize };
